; Tape2tap v1.20 - digitalizes spectrum tapes in a PC (MS-DOS)
;                  through a SoundBlaster or the printer port
;                  ()96 Rui Fernando Ferreira Ribeiro

; Tape2Tap v1.20.3b - ।  ᢮  + 䥩 ;)
;                     + ⠭  ⥯ 뢮.
;                     ணࠬ 饭  ᮪饭  3 ࠧ...
;                     ஬ ⮣   ⪮஢,  ᬮ
;                        ࠢ,  ⭮ ࠫ ;)
;                       ࠡ... 믠... ;)))
; (f)99 Mihal Soft   客 堨  2:5093/6.1 /9.1 /16.1 /17.1

SENSITIVITY EQU 083h
; ᠬ  㤥 ࠬ.
;⠭  SB 祭   ࠢ ⮡ । - ⠭ 0  1
;083h -    Aztech SoundGalaxy Washington 16 (SB PRO)
;0E0h -  Creative Sound Blster AWE 32
;   㣨 祪 -    ;)
; 祬  뢠  ADC 祭  ࠧ 窠
;ࠧ -  ⮦  ...    ,  堫 ;)

;------------------------------------------------------
; ६ ࢠ, ⠭  .

LOW_IMP         equ     1200   ;-⮭
HI_IMP          equ     2600

LOW_SYNC        equ     1200   ;ᨭ-
HI_SYNC         equ     1800

TRANSITION      equ     800    ;६ "࠭" / ਮ "1"  "0"

WAIT_VAL        equ     300
NIMP            equ     50     ;᪮쪮 ᮢ ⮭ 
BAD_HI          equ     4000   ;ᨬ ਮ " ᨣ"

;ᬥ饭 ⮢    SB
RESET           equ     6
MIXER           equ     4
WRITE           equ     0Ch
READ            equ     0Ah
DATA_AVAIL      equ     0Eh

READY           equ     0AAh    ; "" 뤠 SB   READ

FIRST_PORT      equ     0200h   ;   ண 稭  SB

;梥  訢  EGA/VGA
BLACK           equ     0
BLUE            equ     1
RED             equ     4
YELLOW          equ     6
;----------------------------------------------------------------------------

.8086           ;  㦥 ਫ,   ⨪ਠ? ;)
.model  tiny

T2T_CODE SEGMENT 'CODE' USE16

        ASSUME CS:T2T_CODE, DS:T2T_CODE

        ORG     0100h
Start:
        mov     al, 1
        int     10h             ;⥪⮢ ० 4025 ( ਪ)

        mov     ah, 9
        mov     dx, OFFSET Copyrt
        int     21h

        mov     ax, 0b800h      ;㥬 梥⭮   ࠭
        mov     es, ax          ;...㦥⢥ 䥩 ;)
        mov     si, offset menu
        mov     di, 24*40*2
        cld
OutMenu:
        lodsb
        cmp     al, 0
        jz      endMenu
        cmp     al, 80h
        jb      OutChar
        and     al, 7fh
        mov     ah, al
        jmp SHORT OutMenu
OutChar:
        stosw
        jmp SHORT OutMenu
endMenu:                        ;稫  

        mov     ax, cs          ;"७ᥬ" ES
        add     ax, 4096        ; 64k (4096 ࠣ)  PSP
        mov     es, ax          ;ES 㤥 㪠뢠   

;㧭  LPT1
        xor     ax, ax
        mov     ds, ax
        mov     ax, DS:[0408h]  ; LPT1    BIOS
        inc     ax              ;+1 =  ᭮ 
        push    cs
        pop     ds
        mov     Printer_Port, ax

;஢塞  ப   "/p" ( ஢ SB)
        cmp     WORD PTR DS:[82h], 'p/'  ;祭 饭 ஢ઠ ;)
        jz      no_sblaster

SB_Detect_Need:

;樠 SB (RESET_DSP)
        mov     dx, FIRST_PORT  ; 
ScanForDSP:
        add     dx, RESET       ;DX= RESET (2x6)
        mov     al, 1           ;襬 1   
        out     dx, al
;INIT_COUNT
        call    READ_PIT
        mov     bp, ax          ;࠭塞 ⥪ 祭 ⠩

waitRD:                         ; 30 ⨪ PIT
        call    READ_PIT
        sub     ax, bp          ;ࠧ  砫 祭
        jns     end_Gcnt        ;᫨ ⥫쭠
        neg     ax              ; ४㥬
end_Gcnt:
        cmp     ax, 30          ;ࠧ ⨣ 30 ⨪?
        jc      waitRD          ;᫨  ,  

        xor     al, al
        out     dx, al          ;襬 0   

        mov     cx, 100
        add     dx, READ-RESET  ;DX= READ
Is_DSP:
        in      al, dx          ;஥ ६ (100 横)
        cmp     al, READY       ; "⮢" DSP
        jz      Found_DSP       ;᫨ ,   樠஢
        loop    Is_DSP

        sub     dx, READ-10h    ;室  ᫥饬   SB

        cmp     dx, 02A0h       ;  ਠ?
        jnz     ScanForDSP      ;᫨  - த

        jmp SHORT no_sblaster   ; - SB  

found_DSP:
        sub     dx, READ
        mov     SB_base_addr, dx
; RESET_DSP

;ணࠬ㥬  SB (INIT_MIXER)
        mov  ax, 070Ch          ;筨=Line-in, 䨫=LOW
        CALL WRITE_MIXER
        mov  ax, 0FF2Eh         ;஬ Line-in = 16,16
        CALL WRITE_MIXER
        mov  ax, 0FF22h         ;஬  (MASTER) = 16,16
        CALL WRITE_MIXER
        jmp SHORT pre_begin     ;樠 SB 祭

;᫨ SB    ⪫祭   ப ...
no_sblaster:

pre_begin:
        cli
        in      al, 61h         ;࠭ ᮤন "ᯨ୮" 
        mov     Copy_p61h, al

; : ॣ DX     横!
; ⮬, ⮢  ﭭ ࠭   (SB  LPT)
;  ண  ⠥ ᪨ ( ᪨)  

begin:
        cli
        mov     si,2             ;   ES:SI 㤥  

        mov     dx, SB_base_addr ;⠥  ⠥  SB
        or      dx, dx           ; ᫨  "⪫祭"
        jnz     no_imp

        mov     dx, Printer_Port ; ⠥  LPT

; try to find
no_imp:
        mov     Colour, RED
        mov     bh,0            ;稪 ᮢ -⮭

imp_again:
        call    ReadVal         ;  祣-  
        jnz     no_imp

;稭  -⮭
imp_low:
        call    ReadCycle       ;塞 ⥫쭮  ਮ
another_imp:
        cmp     ax,LOW_IMP      ;஢塞, 宦   -⮭
        jc      no_imp
        cmp     ax,HI_IMP
        jnc     no_imp
        cmp     cx,LOW_IMP
        jc      no_imp
        cmp     cx,HI_IMP
        jnc     no_imp
        inc     bh              ;,   業 
        cmp     bh,NIMP         ;筮 -⮭ 㦥 ""?
        jz      wait_sync
        jmp     SHORT imp_again ;᫨ ,     

wait_sync:                      ; 稭  
        call    ReadCycle
        cmp     ax,HI_SYNC      ;宦   ᨭ-?
        jnc     no_sync
        cmp     ax,LOW_SYNC
        jc      prep_l8bits     ;᫨  ᨭந,   
no_sync:
        mov     bh, NIMP-1      ; ஢ਬ     -⮭
        jmp     SHORT another_imp

;-⮭ , ᨭ- , ६ ᮡ ...
;...    ;)
prep_l8bits:
        mov     bl,0            ; 㤥 ⥪饥 祭 CRC
        mov     Colour, YELLOW  ;梥 
l8bits:
        mov     bh,1            ; 㤥 ...
                                ; "1" ⮡ 뫥᫥ ⥭ 쬮 
lbits:
        call    ReadCycle       ;⠥ 1 ਮ
        cmp     ax,BAD_HI
        jnc     end_load        ;-  ⠪ -  室 ஢

        cmp     ax, TRANSITION  ;஢ਬ   0  1
        cmc                     ;㥬 䫠 ७
        rcl     bh,1            ;ᨬ ।   BH
        jnc     lbits           ;᫨  쬨 ⠫,  ...

byte_read:
        mov     byte ptr es:[si],bh ; ⠭, ࠭ 
        xor     bl,bh           ; 뢠  ஫ 㬬
        inc     si              ;㪠⥫ 㤠  ४㥬
        jmp     l8bits          ;    1 

end_load:
;  - 稭   ...
;  뫠 訡 ⥭,     稫.
;   ᥩ  ஢ਬ...

        mov     al, Copy_p61h
        out     61h,al          ;⠭ ᮤন "ᯨ୮" 

        mov     ah,BLACK
        call    Border          ; - 

        sti

        cmp     si,1            ;-  ⠭?
        ja      sa_block        ;,  ஢/࠭
        jmp     leave_this      ;, 室...

sa_block:
        dec     si              ;४㥬... SI =  ⠭ 
        dec     si
        call    PutLength       ;८ࠧ㥬    ப  
        mov     word ptr es:[0],si  ;ᨬ   "" .TAP-䠩
        inc     si              ;頥   
        inc     si

        cmp     SpecCRC, 0      ;ᬮਬ 䫠 "  ஢ CRC?"
        jz      ok_2_load       ;᫨  ,    "ᯥ譮"

all_korret:
        cmp     bl,0            ;஢塞 "諠"  CRC 
        jz      ok_2_load       ;᫨ ,   
        lea     dx,tape_error   ; - "R-Tape loading error"
        call    PRINT_STRING
        jmp     leave_this      ; 室

; ᫨  ⠫ ଠ쭮 - ⠥  室 䠩
ok_2_load:
        mov     ax,3d01h        ;뢠  ⥭
        mov     dx,offset File
        int     21h
        jnc     file_open2      ;᫨  - 
        mov     ah,3ch          ; - ஡㥬 ᮧ ⠪ 䠩
        xor     cx,cx
        int     21h
        jc      leave_prog      ;᫨    ᮧ :( 室  ண

file_open2:
        xchg    ax, bx          ;࠭塞 

        mov     ax,4202h        ;⠭ 㪠⥫   䠩
        xor     cx,cx
        xor     dx,dx
        int     21h

        push    ds
        push    es
        pop     ds              ;㪠 DS:DX  ࠭塞 
        mov     dx,0
        mov     cx,si           ; CX  
        mov     ah,40h          ;࠭塞
        int     21h

        pop     ds              ;⠭ DS


        mov     ah,3eh          ;஥ 䠩
        int     21h

        lea     dx,messg_good   ;ᮮ饭  ᯥ譮 㧪
        call    PRINT_STRING

        cmp     si,21           ;    ? (17 )
        jnz     exit            ;᫨ , 室
        cmp     byte ptr es:[2],0 ;筮 ?
        jne     exit            ;᫨ , 室
        cmp     byte ptr es:[3],0 ; ணࠬ?
        jnz     no_basic
        lea     dx,b_program
        jmp     all_ok
no_basic:
        cmp     byte ptr es:[3],3 ;  ?
        jnz     exit
        lea     dx,b_code

all_ok:
        mov     ah, 9
        int     21h             ;뤠 "Program"  "Bytes"

;६    "" ᨬ, ⮡  
        mov     bh,0
        mov     di,4
another_char:
        mov     al,byte ptr es:[di]
        cmp     al,32
        jnc     char_ok
        mov     al,'?'
char_ok:
        mov     ah,0eh
        int     10h             ;뢮 1 㪢
        inc     di
        cmp     di,14
        jnz     another_char

exit:

leave_this:
        jmp     begin           ;     ...

;᫨ 䠩 騡,  짮⥫  ,  室
leave_prog:
        mov     al, CS:Copy_p61h
        out     61h, al         ;⠭ "ᯨ" 

        mov     ah,BLACK        ; - 
        call    Border
        sti

        mov     al, 3           ;० 8025
        int     10h
        mov     ah, 4ch         ; 襥 - 砥...
        int     21h             ;!

;---------------------------------------------------------------------------
InitRead        proc    near

Wait_V:
        call    READ_PIT
        call    GiveCount

        cmp     Colour, YELLOW
        jne     Leave_R
        cmp     ax,WAIT_VAL
        jc      Wait_V

Leave_R:
        ret
InitRead        endp

;---------------------------------------------------------------------------
GiveCount       proc    near
        sub     ax, bp
        jns     End_Cnt         ;ࠧ  ⠩ ⥫쭠?
        neg     ax              ;᫨ ,  ᪮४㥬
End_Cnt:
        ret
GiveCount       endp

;---------------------------------------------------------------------------
;⥭    
ReadVal         proc    near
;TEST_BREAK
        mov     ax, 0b800h
        mov     ds, ax

        in      al, 60h         ;⠥  
        or      al, al
        js      nokey           ;᫨   

        cmp     al, 16          ;᪠  'Q' ?
        jz      leave_prog      ;᫨  - 室  ணࠬ
        cmp     al, 1           ;᪠  'ESC' ?
        jz      leave_prog      ;᫨  - 室  ணࠬ

test_1: cmp     al, 46          ;᪠  'C' ? (CRC)
        jnz     test_S          ;᫨   ஢ ᫥ 
        xor     CS:SpecCRC, 1   ; ४砥 ﭨ 䫠 ஢ન
        mov     bx, 'ff'
        jz      OnCRC
        mov     bx, 'n '
OnCRC:
        mov BYTE PTR DS:[24*40*2+40], bh
        mov BYTE PTR DS:[24*40*2+42], bl
test_S:
        cmp     al, 31          ;᪠  'S' ?   (SPEAKER)
        jnz     test_P          ;᫨   ஢ ᫥ 
        xor     CS:Speaker_On, 1; ४砥 ﭨ 䫠 頭
        mov     bx, 'ff'
        jz      OnSPEAK
        mov     bx, 'n '
OnSPEAK:
        mov BYTE PTR DS:[24*40*2+64], bh
        mov BYTE PTR DS:[24*40*2+66], bl

Test_P:
        cmp     al, 25          ;᪠  'P' ? (PORT)
        jnz     nokey           ;᫨   
        xor     dx, dx
        mov     CS:SB_base_addr, dx ;⪫ ᯮ짮 SB
        mov     dx, CS:Printer_Port ; ᯮ짮 LPT

nokey:
; ஢ન ࠧ ⪥

        push    cs
        pop     ds

        cmp     SB_base_addr, 0 ;  ᯮ SB ?
        jnz     Use_SB          ;᫨  -   ⥭  SB

        mov  ax, 0B800h         ; - ⠥  LPT
        mov  ds, ax
        mov  BYTE PTR DS:[24*40*2+22],'L' ;襬  ப  'LPT'
        mov  BYTE PTR DS:[24*40*2+24],'P' ;   - ਢ
        mov  BYTE PTR DS:[24*40*2+26],'T' ; ᪮쪮   ;)
        push cs
        pop  ds

;⠥ 祭    LPT- (READ_LPT)
        in      al,dx           ;⠥   ᭮ 
                                ;⭮   BUZY (00/80h)
        jmp     SHORT Sound     ; /  ᯨ஬

;⥭   SB ( ADC)
;१ (⠭ 0  1) 頥  䫠 Z
Use_SB:
        add     dx, WRITE       ;   
poll_waitW:
        in      al,dx
        or      al,al
        js      poll_waitW      ; ⮢ ਭ 
        mov     al,020h
        out     dx,al
        sub     dx,WRITE        ;뢮  20h (㤥  1 )
        add     dx,DATA_AVAIL
poll_waitR:
        in      al,dx
        or      al,al
        jns     poll_waitR      ;  DSP ⮢  
        sub     dx,DATA_AVAIL-READ
        in      al,dx           ;⠥   ADC
        sub     dx,READ

        cmp     al, SENSITIVITY ;ᬮਬ ⠭ 0  1 ?
        mov     al, 080h        ;।
        ja      val_ok
        xor     al,al           ;⠭ 0
val_ok:
; READ_SB

;⥯ 騬 (  騬) ᯨ஬
Sound:
        push    cx
        mov     cl, 6           ;⮢ al  뢮  ᯨ
        shr     al, cl          ;al = 00000000b  00000010b
        pop     cx

        cmp     Speaker_ON, 0   ;䫠 頭 襭?
        jz      NoSound         ;᫨  -   
        out     61h, al         ;騬
NoSound:
        and     al,00000010b    ;⠭ 䫠 Z  ᮮ⢥⢨
                                ; ⥬,  ⠫
        ret
ReadVal         endp

;---------------------------------------------------------------------------
;楤 "梥 " ( ;)
; ᫮ 룫廊   ࠭ "" 쪠
;  㣮, ,  室...
Border          proc    near    ; ah - 梥

        push    dx
        mov     dx,03DAh
wait_retrace:
        in      al,dx
        test    al,8
        jnz     wait_retrace    ;  vertical retrace

        mov     dx,03C0h
        mov     al,11h          ;ॣ = 梥 
        out     dx,al
        mov     al,ah
        out     dx,al           ;뢮 梥

        mov     al,20h          ;ਬ,   ⮫쪮 
        out     dx,al
        pop     dx

        ret
Border          endp

;---------------------------------------------------------------------------
;⠥ 祣   100 ⮢   䮭 0  1 (த  ;)
;㡮 ,   , பᨬ   ⠪
SampleVal       proc    near
        call    READ_PIT
        mov     Init_Sampl, ax

        xor     ax,ax
        mov     N_zeros, ax
        mov     N_ones, ax
LoopPulse:
        call    ReadVal
        jz      Is_Zero
        call    READ_PIT
        mov     L_one, ax
        cmp     N_zeros, 0
        jnz     Dec_Czeros
        cmp     N_ones, 0ffffh
        jz      End_Pulse
        inc     N_ones
        jmp     SHORT End_Pulse
Dec_Czeros:
        dec     N_zeros
        jmp     SHORT End_Pulse

Is_Zero:
        call    READ_PIT
        mov     L_zero, ax
        cmp     N_ones, 0
        jnz     Dec_Cones
        cmp     N_zeros, 0ffffh
        jz      End_Pulse
        inc     N_zeros
        jmp     SHORT End_Pulse
Dec_Cones:
        dec     N_ones

End_Pulse:
        call    READ_PIT
        sub     ax, Init_Sampl
        jns     Sign_OK
        neg     ax
Sign_OK:
        cmp     ax,100
        jb      LoopPulse

        mov     ax, N_zeros
        cmp     ax, N_ones
        ret
SampleVal       endp

;---------------------------------------------------------------------------
;⥭   ( )
ReadCycle       proc    near
        mov     ah,BLUE
        call    Border
        mov     bp, L_one
        xor     cx,cx
        call    InitRead
Low_Part:
        call    SampleVal
        jae     Low_Part
        mov     ax, L_zero
        call    GiveCount
        mov     cx,ax

        cmp     ax,BAD_HI
        jnc     Leave_Read

        mov     ah, Colour
        call    Border
        mov     bp, L_zero
        call    InitRead

HI_Part:
        call    SampleVal
        jbe     HI_Part
        mov     ax, L_one
        call    GiveCount
Leave_Read:
        ret
ReadCycle       endp

;---------------------------------------------------------------------------
; 祭    SB
WRITE_MIXER     proc near    ;AL=ॣ, AH=祭
        add     dx,MIXER
        out     dx,al
        inc     dx
        xchg    al,ah
        out     dx,al
        sub     dx,MIXER+1
        retn
WRITE_MIXER     ENDP

;---------------------------------------------------------------------------
;⥭ ⠩ (PIT 8253)  0
READ_PIT        proc near
        xor     al, al          ;0 =  0 
        out     43h,al          ; ࠢ
        in      al,40h          ;⠥ LSB
        mov     ah,al
        in      al,40h          ;⠥ MSB
        xchg    ah,al
        ret
READ_PIT        ENDP

;---------------------------------------------------------------------------
; ப  ""...  ண  ப ࠭ (⠬  ;)
PRINT_STRING    proc near
                push    dx
                mov     ax, 0602h ;   1 ப
                mov     bh,    7h ;ਡ
                xor     cx, cx    ;孨  㣮
                mov     dx, 1727h ; ࠢ 㣮
                int     10h       ;ப稢  
                mov     ah, 2
                xor     bx, bx
                mov     dx, 1600h
                int     10h       ;⠭   22,0
                pop     dx
                mov     ah,9
                int     21h       ;⠥ ப
                ret
PRINT_STRING    ENDP
;---------------------------------------------------------------------------
;८ࠧ  ⠭  ( SI)  ப  뢮  ࠭
PutLength       PROC NEAR
                push bx
                mov  ax, si
                dec  ax      ; 䫠 0/255
                dec  ax      ; ஫쭠 㬬
                mov  bx, 4   ;- ᨬ  ப - 1
                mov  cx, 10  ;筠 ⥬ ᫥
NumToStrLoop:
                xor  dx, dx
                div  cx
                add  dl, '0'
                mov  BlockLen[bx], dl
                dec  bx
                jns  NumToStrLoop

                pop  bx
                ret
PutLength       ENDP

;---------------------------------------------------------------------------
;   

Speaker_ON      db      0       ; 㬮砭 뢮  ᯨ 몫祭
Init_Sampl      dw      0
SpecCRC         db      1       ;䫠 "஢  ஫ 㬬?"

Copy_p61h       db      0
Colour          db      0       ;梥 
Printer_Port    dw      0379h

N_zeros         dw      0
N_ones          dw      0
L_zero          dw      0
L_one           dw      0

SB_base_addr    dw      0

File        db 'in.tap', 0      ; 室 䠩

b_program   db 'Program: $'
b_code      db 'Bytes  : $'

Copyrt      db 'Tape2Tap v1.20.3b',0dh,0ah
            db '⥭  ZX Spectrum  PC',0dh,0ah
            db '()96 Rui Fernando Ferreira Ribeiro',0dh,0ah
            db '(f)99 Mihal Soft   客 堨',0dh,0ah
            db '      2:5093/6.1 /9.1 /16.1 /17.1',0dh,0ah,'$'

tape_error  db 'R-Tape loading error!',7,'$'

messg_good  db 'Loaded '
BlockLen    db '00000b. $'
menu        db 9Bh,'MENU: ',9Eh,'P',9Fh,'ort=SB  ',9Eh,'C',9Fh,'RC:On  ',9Eh,'S',9Fh,'peaker:Off ',9Eh,'Q',9Fh,'uit '

T2T_CODE ENDS

end     Start

; EOF: Tape2Tap.asm
